﻿using SushiBarContracts.BindingModels;
using SushiBarContracts.ViewModels;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace SushiBarDatabaseImplement.Models
{
    public class Promotion
    {
        [Key]
        public int Id { get; set; }

        [Required]
        public string PromotionName { get; set; } = string.Empty;

        [Required]
        public float Discount { get; set; }

        [Required]
        public double TriggeringSum { get; set; }

        [ForeignKey("PromotionId")]
        public virtual List<Cheque> Cheques { get; set; } = new();

        public static Promotion? Create(PromotionBindingModel Model)
        {
            return new Promotion()
            {
                PromotionName = Model.PromotionName,
                Discount = Model.Discount,
                TriggeringSum = Model.TriggeringSum,
            };
        }

        public void Update(PromotionBindingModel Model)
        {
            PromotionName = Model.PromotionName;
            Discount = Model.Discount;
            TriggeringSum = Model.TriggeringSum;
        }

        public PromotionViewModel ViewModel => new()
        {
            PromotionName = PromotionName,
            Discount = Discount,
            TriggeringSum = TriggeringSum,
        };
    }
}
