﻿using Microsoft.EntityFrameworkCore;
using SushiBarDatabaseImplement.Models;

namespace SushiBarDatabaseImplement
{
    public class SushiBarDatabase : DbContext
    {
        protected override void OnConfiguring(DbContextOptionsBuilder OptionsBuilder)
        {
            if (OptionsBuilder.IsConfigured == false)
            {
                //OptionsBuilder.UseNpgsql(@"Host=192.168.56.101;Port=5436;Database=postgres;Username=postgres;Password=admin");
                OptionsBuilder.UseNpgsql(@"Host=localhost;Port=5000;Database=SushiBarTest;Username=postgres;Password=admin");
            }
            base.OnConfiguring(OptionsBuilder);
            
            AppContext.SetSwitch("Npgsql.EnableLegacyTimestampBehavior", true);
            AppContext.SetSwitch("Npgsql.DisableDataTimeInfinityConversions", true);
        }

        public virtual DbSet<Dish> Dishes { get; set; }

        public virtual DbSet<Ingredient> Ingredients { get; set; }

        public virtual DbSet<DishIngredient> DishIngredients { get; set; }

        public virtual DbSet<Cheque> Cheques { get; set; }

        public virtual DbSet<ChequeItem> ChequeItems { get; set; }

        public virtual DbSet<Cook> Cooks { get; set; }

        public virtual DbSet<Customer> Customers { get; set; }

        public virtual DbSet<Promotion> Promotions { get; set; }
    }
}
